﻿Imports System.Collections.Generic
Imports System.Drawing

''' <summary>
''' 
''' </summary>
''' <remarks>更新はCanvasまで。SurfaceはUI側で更新。</remarks>
Public Class UpdateCanvas : Inherits Command : Implements Visitor

    'Private _image As Bitmap
    Private _tiles As New List(Of BrokenTile)

    Public Overloads Sub Visit(ByVal canvas As Canvas) Implements Visitor.Visit

        'TODO:1つのUpdateCanvasインスタンスではCanvas1つだけを処理。再帰的な仕組み。UpdateCanvasから複数のUpdateCanvasを生成。

        Me._tiles = canvas.GetBrokenTiles()
        canvas.ClearBrokenTiles()

        With Nothing
            Dim members As List(Of LayerListMember) = canvas.UpwardMember()

            For idx As Integer = 0 To members.Count - 1
                Debug.Assert(members.Item(idx) IsNot canvas)
                members.Item(idx).Accept(Me)
            Next
        End With

        ' Canvasの更新
        canvas.FitTiles(Me._tiles)

    End Sub

    Public Overloads Sub Visit(ByVal layer As FilterLayer) Implements Visitor.Visit
        ' TODO:FilterLayer呼び出し
    End Sub

    Public Overloads Sub Visit(ByVal layer As RasterLayer) Implements Visitor.Visit

        For Each tile In Me._tiles
            layer.Repair(tile)

            'Dim rect As RectangleF = BrokenTile.ApexesToRectangleF(tile.Apexes)
            'Using g As Graphics = Graphics.FromImage(tile.ImageClip)
            '    Dim bounds As RectangleF = tile.ImageClip.GetBounds(g.PageUnit)
            '    layer.CarbonCopyTo(g, bounds, rect)
            'End Using
        Next

        'Using g As Graphics = Graphics.FromImage(Me._image)
        '    layer.CarbonCopy(g)
        'End Using

    End Sub

    Public Sub New()
    End Sub

    Private _appEvent As String
    Public Overrides Property AppEvent As String

        Get
            Return Me._appEvent
        End Get

        Set(ByVal value As String)
            Me._appEvent = value
        End Set

    End Property

    Protected Overrides Sub Finalize()

        For i As Integer = 0 To Me._tiles.Count - 1
            Me._tiles(i) = Nothing
        Next
        MyBase.Finalize()

    End Sub

End Class
